package com.eactive.eai.batch.job.jobItem.cfa;

import java.lang.String;
import java.io.ByteArrayOutputStream;

import com.eactive.eai.common.exception.ExceptionUtil;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

public class RECV_CFABT_0810 extends DefaultTelegram implements TelegramService
{

    /**
     * 생성자
     */
    public RECV_CFABT_0810() {
        //여신금융협회 개시/종료/통신망 전문
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;

//        //업무관리정보 유효성 확인
//        if (this.getOpCode().equalsIgnoreCase(this.OpCode_start)) {
//        }
//        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_restart)) {
//        }
//        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_end)) {
//        }
//        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_teset)) {
//        }
//        else {
//            logger.info("{} 0800 telegram : unknown  Operation code received >> "+this.getOpCode(), logHeader);
//            this.setResolveResponseCode("94");
//
//            String[] msgArgs = new String[2];
//            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//            msgArgs[1] = this.getOpCode();
//            String errCode = "BECEAIFJI008";
//            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
//            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//
//        }
        return true;
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<14; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            batchDoc.getBatchMsg().setTelegramBody("");
            
            if ( getOpCode().equals("004")){
                try {
    				int sleepTime = Integer.parseInt(getTelegramInfo().getProperty(TelegramKeys.SLEEP_TIME));
    				Thread.sleep(sleepTime); 
    			} catch (Exception e) {}
            }

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(12);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
		return super.getFieldValueString(11);
    }
}
